﻿using System.Windows;

namespace ProxyAuthenticationExample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public static string UserName { get; set; }
        public static string Password { get; set; }
        public static string Domain { get; set; }

        public void btnConnect_Click(object sender, RoutedEventArgs e)
        {
            ProxyHelper proxyHelper = new ProxyHelper();

            // Check if the user requires authentication
            if (proxyHelper.RequiresAuthentication())
            {
                // First check if the user has already 
                // entered their details in the prompt window
                // You could use the object cache if this was web based.
                if (!string.IsNullOrEmpty(UserName))
                {
                    // Try and authenticate using the credentials supplied
                    bool tryAuthenticate =
                        proxyHelper.TryAuthenticate(UserName, Password, Domain);

                    // If authenticate was unsuccessful then show the prompt again
                    if (!tryAuthenticate)
                    {
                        new ProxyPrompt().Show();
                    }
                    else
                    {
                        // Success
                        MessageBox.Show("Connection Successful");
                    }
                }
                else
                {
                    new ProxyPrompt().Show();
                }
            }
            else
            {
                // Success
                MessageBox.Show("No Authentication Required");
            }
        }
    }
}
